from __future__ import print_function
import networkx as nx
from networkx.readwrite import json_graph
import json


print("NetworkX version = {}".format(nx.__version__))
# Read in a JSON formatted graph file, put your file name in here not mine!
gnl = json.load(open("../exampleNets/MultiSwitchVLANNet1.json"))
print("gnl = {}".format(gnl))
g = json_graph.node_link_graph(gnl)
# Basic node and link info
print("Network nodes: {}".format(g.nodes()))
print("Network links: {}".format(g.edges()))
# Node and Link with extra data properties
print("Network nodes: {}".format(g.nodes(data=True)))
print("Network links: {}".format(g.edges(data=True)))
# Print out node types, example of getting node information
for n in g.nodes():
    # Shows out we get the type of the node,
    node_type = g.node[n].get("type", None)
    vid_info = ""
    # Since not all nodes have vnid we use this form to get the value
    # from the node dictionary. Returns None if "vnid" not there
    node_vid = g.node[n].get("vnid", None)
    if node_vid:
        vid_info = "with vid = {}".format(node_vid)
    print("Node {} is a {} {}".format(n, node_type, vid_info))
# Print out link information with port information
for link in g.edges():
    src = link[0]
    trg = link[1]
    port_info = g[src][trg]["ports"]
    cap = g[src][trg]["capacity"]
    print("link from {} port {} to {} port {} has capacity {}"
          .format(src, port_info[src], trg, port_info[trg], cap))


